"""
    This script has high priority.
    Other event handlers may wish the IAL to be up-to-date.
"""

from string import split,upper
#from ui import echo                      # for talking to the front end
from script import event,display,alias,load # for talking to the back end (*and ourselves*)
#from sys import exit
import ui
#import conxn
#import cfg
#import sys                               # for sys.modules

#if not reloading:
ial_nicks={}                             # dictionary of dictionaries, indexed by nick
ial_channels={}                          # dictionary of lists, indexed by channel
mynick=''

uncase=upper

def event_001(args):
    """ :wobble 001 mini-mike :Welcome to the Internet Relay Network nickname """
#    display('ial',args)
    global mynick
    mynick=split(args,' ')[2]
    display('ial','My nick set to '+mynick)

def event_353(args):
    """ :mpx.sydney.oz.org 353 mini-mike = #chat :mini-mike Farkwit Lazydino michae1 jo_work Obsydian @Z """
    # there will be a problem is a channel /names list gets split into multiple 353's
    # (on oz.org there will be (int(N-1)/60+1) 353 replies)

    global mynick,ial_nicks,ial_channels

    display('ial',args)
    channel,nicks=split(args,' ',5)[4:]
    channel=uncase(channel)
    nicks=split(nicks[1:],' ')
    if not nicks[-1]:
        nicks=nicks[:-1] # remove possible empty element (353 list has space on the end)
    for n in range(len(nicks)):
        if nicks[n][0]=='@': nicks[n]=nicks[n][1:]
        if not ial_nicks.has_key(nicks[n]):
            ial_nicks[nicks[n]]={}
            # userhost user here?
    ial_channels[channel]=nicks

def event_NICK(args):
    """ args=':nick[!user@host] NICK :newnick' """
    # second colon omitted if a result of failed nick change (too fast)...!
    # no idea if userhost is omitted ever...
    global mynick,ial_nicks,ial_channels

    user,cmd,newnick=split(args,' ',2)
    if newnick[0]==':':               # Is this [not?] the broken failed nick change message from oz.org?
        newnick=newnick[1:] # remove colon before nickname that may or may not be there
    
    oldnick,userhost=split(user[1:],'!',1)
    if oldnick==mynick:
        mynick=newnick

    ial_nicks[newnick]=ial_nicks[oldnick]
    del ial_nicks[oldnick]
    display('ial',split(user[1:],'!',1)[0]+' is now '+newnick+' in:')
    for c in ial_channels.keys():
        chanlist=ial_channels[c]
        if oldnick in chanlist:
            chanlist[chanlist.index(oldnick)]=newnick
            display('ial','      '+c)

def event_JOIN(args):
    """ args=':nick!user@host JOIN :#channel' """
    global mynick,ial_nicks,ial_channels

#    display("ial",'join: '+args)
    args=split(args,' ',3)
    nick,userhost=split(args[0][1:],'!',1)
    channel=uncase(args[2][1:])
    ial_nicks[nick]={'userhost':userhost}
    #display('ial','nick:%(nick)s mynick:%(mynick)s' % vars())
#    display('ial','nick:%s mynick:%s' % (nick,mynick))
    if nick==mynick:
        ial_channels[channel]=[]
    ial_channels[channel].insert(0,nick)
    display('ial',nick+'('+userhost+') added to '+channel)

def event_PART(args):
    """ args=':nick!user@host PART #channel' """
    global ial_nicks,ial_channels

#    display("ial",'part: '+args)
    args=split(args,' ',3)
    nick,userhost=split(args[0][1:],'!',1)
    channel=uncase(args[2])
    ial_channels[channel].remove(nick)
    display('ial',nick+'('+userhost+') parted from '+channel)

def event_KICK(args):
    """ args=':Z!zed@dead.oz.org KICK #perth Laiana :(thebar) fat ass!' """
    args=split(args,' ',4)               # source, KICK, channel, who, reason
    channel=uncase(args[2])
    nick=args[3]
    ial_channels[channel].remove(nick)
    display('ial',nick+' kicked from '+channel)

def event_QUIT(args):
    """ args=':elusion!acr@Jedi-257.nw.com.au QUIT :I seek son, decieve none for' """
    args=split(args,' ',2)
    nick,userhost=split(args[0][1:],'!',1)
    display('ial',nick+' quitted from:')
    for c in ial_channels.keys():
        if nick in ial_channels[c]:
            ial_channels[c].remove(nick)
            display('ial','    '+c)

def alias_dump(args):
    display('ial','Channels:')
    for c in ial_channels.keys():
        display('ial','    '+c+': '+str(ial_channels[c]))
    display('ial','Nicknames:')
    for n in ial_nicks.keys():
        display('ial','    '+n+': '+str(ial_nicks[n]))

def alias_ial(args):
    if ui.find('.IAL'):
        pass
    else:
        ui.StatusWindow('.IAL',ui.Rect(60,20,111,40))

def display_ial(args):
    if ui.find('.IAL'):
        ui.echo('.IAL',args)
    else:
        ui.echo('.status','IAL: '+args)

alias_ial(None)